<template>
  <div>
    <div class="container-fluid mb-5 mt-4">
      <div class="row">
        <div class="col-lg-6">
          <div class="card border-0 shadow rounded">
            <div class="card-body">
              <!-- text header -->
              <h5 class="text-left font-weight-bold">Product Details</h5>
              <div v-for="cart in carts" :key="cart.id">
                <hr />
                <div class="row mb-4">
                  <div class="col-12 col-md-4">
                    <div class="wrapper-image-cart" style="width: 165px">
                      <!-- product image -->
                      <img :src="cart.product.image" style="width: 95%; height: 125px; border-radius: .5rem"
                        class="img-fluid mb-2">
                    </div>
                  </div>
                  <div class="col-12 col-md-5 text-left ml-1 ml-md-0">
                    <!-- product title -->
                    <h5 style="font-size: 1rem">
                      <strong>{{ cart.product.title }}</strong>
                    </h5>
                    <!-- product quantity and remove product -->
                    <div class="d-flex justify-content-between">
                      <span>Quantity: {{ cart.quantity }}</span>
                      <button @click="removeCart(cart.id)" class="btn btn-sm btn-danger">
                      <i class="fa fa-trash"></i>
                      </button>
                    </div>
                  </div>
                  <!-- product cart price -->
                  <div class="col-12 col-md-3 text-left mb-2">
                    Rp {{ moneyFormat(cart.price) }} <br>
                    Rp <del style="text-decoration-color: red;">{{ moneyFormat(cart.product.price * cart.quantity)}}</del>
                  </div>
                </div>
              </div>

              <div class="table-responsive">
                <table class="table table-default border-0">
                  <tbody>
                    <tr>
                      <td class="set-td text-left" width="60%">
                        <p class="m-0">Price</p>
                      </td>
                      <td class="set-td text-right" width="30%">
                        &nbsp; : Rp
                      </td>
                      <td class="text-right set-td">
                        <p class="m-0" id="subtotal">
                          {{ moneyFormat(cartTotal) }}
                        </p>
                      </td>
                    </tr>
                    <!-- shipping cost -->
                    <tr>
                      <td class="set-td text-left border-0">
                        <p class="m-0">
                          Shipping Cost (<strong>{{ cartWeight }}</strong> gr)
                        </p>
                      </td>
                      <td class="set-td border-0 text-right">&nbsp; : Rp</td>
                      <td class="set-td border-0 text-right">
                        <p class="m-0" id="ongkir-cart">{{ moneyFormat(state.courier_cost) }}</p>
                      </td>
                    </tr>

                    <!-- grand total -->
                    <tr>
                      <td class="text-left border-0">
                        <p class="font-weight-bold m-0 h5">
                          Grand Total
                        </p>
                      </td>
                      <td class="border-0 text-right">&nbsp; : Rp</td>
                      <td class="border-0 text-right">
                        <p class="font-weight-bold m-0 h5" align="right">{{ moneyFormat(state.grandTotal) }}</p>
                      </td>
                    </tr>
                  </tbody>
                </table>
              </div>
            </div>
          </div>
        </div>
        <div class="col-lg-6 mt-4 mt-lg-0">
          <div class="card border-0 shadow rounded">
            <!-- start ongkos kirim -->

            <div class="card-body text-left">
              <h5><strong> Delivery Details</strong></h5>
              <hr />

              <div class="row">
                <!-- full name -->
                <div class="col-md-6">
                  <div class="form-group">
                    <label for="full_name" class="form-label font-weight-bold">Full Name</label>
                    <input type="text" class="form-control" id="full_name" v-model="state.name">
                    <div v-if="validation.name" class="mt-2" style="color: red;">
                      <strong>The full name field is required.</strong>
                    </div>
                  </div>
                </div>

                <!-- phone -->
                <div class="col-md-6">
                  <div class="form-group">
                    <label for="phone" class="form-label font-weight-bold">Phone Number / WhatsApp</label>
                    <input type="number" class="form-control" id="phone" v-model="state.phone">
                    <div v-if="validation.phone" class="mt-2" style="color: red;">
                      <strong>The phone number field is required.</strong>
                    </div>
                  </div>
                </div>

                <!-- province -->
                <div class="col-md-12">
                  <div class="form-group">
                    <label for="province" class="form-label font-weight-bold">Province</label>
                    <select class="form-control" id="province" v-model="state.province_id" @change="getCities">
                      <option value="" disabled>Choose province</option>
                      <option v-for="province in state.provinces" :key="province.id" :value="province.id">
                        {{ province.name }}
                      </option>
                    </select>
                  </div>
                </div>

                <!-- cities -->
                <div class="col-md-12">
                  <div class="form-group">
                    <label for="cities" class="form-label font-weight-bold">City</label>
                    <select class="form-control" id="cities" v-model="state.city_id" @change="getCourier">
                      <option value="" disabled>Choose city</option>
                      <option v-for="city in state.cities" :key="city.id" :value="city.id">
                        {{ city.name }}
                      </option>
                    </select>
                  </div>
                </div>

                <!-- courier -->
                <div class="col-md-12">
                  <div class="form-group" v-if="state.courier">
                    <label for="courier" class="form-label font-weight-bold">Courier</label>
                    <br>
                    <div class="form-check form-check-inline">
                      <!-- jne -->
                      <input type="radio" name="courier" class="form-check-input select-courier" id="cost_courier-jne"
                        value="jne" v-model="state.courier_type" @change="getOngkir">
                      <label for="cost_courier-jne" class="form-check-label font-weight-bold mr-4">JNE</label>

                      <!-- pos -->
                      <input type="radio" name="courier" class="form-check-input select-courier" id="cost_courier-pos"
                        value="pos" v-model="state.courier_type" @change="getOngkir">
                      <label for="cost_courier-pos" class="form-check-label font-weight-bold mr-4">POS</label>
                    </div>
                  </div>
                </div>

                <!-- service courier -->
                <div class="col-md-12">
                  <div class="form-group" v-if="state.cost">
                    <label class="form-label font-weight-bold">Service Courier</label>
                    <br>
                    <div v-for="value in state.costs" :key="value.service" class="form-check form-check-inline">
                      <input type="radio" class="form-check-input" name="cost" :id="value.service"
                        :value="value.cost[0].value + '|' + value.service" v-model="state.costService"
                        @change="getCostService">
                      <label :for="value.service" class="form-check-label font-weight-bold mr-5">
                        {{ value.service }} - Rp {{ moneyFormat(value.cost[0].value) }}
                      </label>
                    </div>
                  </div>
                </div>

                <!-- address -->
                <div class="col-md-12">
                  <div class="form-group">
                    <label for="address" class="form-label font-weight-bold">Address</label>
                    <textarea class="form-control" id="address" cols="30" rows="5" v-model="state.address"></textarea>
                    <div v-if="validation.address" class="mt-2" style="color: red;">
                      <strong>The address field is required.</strong>
                    </div>
                  </div>
                </div>

                <!-- button checkout -->
                <div v-if="state.buttonCheckout" class="col-md-12">
                  <button @click.prevent="checkout" class="btn btn-primary btn-lg btn-block border-0">Checkout</button>
                </div>

              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { onMounted, computed, reactive } from "vue";
import { useStore } from "vuex"; // <-- vuex
import Api from '../../api/Api' // global API endpoint
import { useRouter } from 'vue-router' // vue router

export default {
  name: "CartComponent",

  setup() {
    // store vuex
    const store = useStore();

    // use router
    const router = useRouter();
    // mounted cart
    onMounted(() => {
      // menjalankan beberapa actions di module cart
      store.dispatch("cart/cartCount"); // untuk memanggil action "cartCount" di module "cart"
      store.dispatch("cart/cartTotal"); // untuk memanggil action "cartTotal" di module "cart"
      store.dispatch("cart/cartWeight"); // untuk memanggil action "cartWeight" di module "cart"
      store.dispatch('auth/getUser');
    });

    // get data cart dari getters cart di module cart
    const carts = computed(() => {
      return store.getters["cart/getCart"];
    });

    // get total cart dari state cartTotal di module cart
    const cartTotal = computed(() => {
      return store.state.cart.cartTotal;
    });

    // get cart weight dari state cartWeight di module cart
    const cartWeight = computed(() => {
      return store.state.cart.cartWeight;
    });

    const user = computed(() => {
      // panggil getters dengan nama "currentUser" dari module "auth"
      return store.getters['auth/currentUser'];
    });

    // function remove cart
    function removeCart(cart_id) {
      // panggil action "removeCart" di module "cart" dengan parameter cart_id
      store.dispatch('cart/removeCart', cart_id);
    }

    // ongkos kirim
    // define state form
    const state = reactive({
      name: '', // state name
      phone: '', // state phone
      address: '', // state address
      provinces: [], // state provinces
      province_id: '', // state id province
      cities: [], // state cities
      city_id: '', // state id city
      courier: false, // state pilih courier
      courier_type: '', // state jenis courier
      cost: false, // state cost courier
      costs: '', // state cost courier
      costService: '', // state get data cost dan service pengiriman
      courier_cost: 0, // state untuk menyimpan cost courier
      courier_service: '', // state untuk menyimpan service courier
      buttonCheckout: false, // state button checkout
      grandTotal: 0, // state untuk grand total  
    })

    // define state validation
    const validation = reactive({
      name: false, // validation name
      phone: false, // validation phone
      address: false, // validation address
    })

    // mounted data provinces
    const provinces = onMounted(() => {
      Api.get('/rajaongkir/provinces')
        .then(response => {
          state.provinces = response.data.data // assign state provinces dengan hasil response
        }).catch(error => {
          console.log(error)
        })
    })

    // function mendapatkan data cities
    function getCities() {
      Api.get('rajaongkir/cities', {
        params: {
          province_id: state.province_id // id province
        }
      })
        .then(response => {
          state.cities = response.data.data // assign state cities dengan data hasil response
        }).catch(error => {
          console.log(error);
        })
    }

    // function menampilkan pilihan courier
    function getCourier() {
      // set state courier menjadi true, untuk menampilkan pilihan kurir
      state.courier = true
    }

    // function get biaya ongkos kirim
    function getOngkir() {
      // check weight product
      if (cartWeight.value == 0) {
        alert('Please select a product first!')
        return
      }

      Api.post('/rajaongkir/checkOngkir', {
        city_destination: state.city_id, // id city
        weight: cartWeight.value, // weight product
        courier: state.courier_type, // jenis courier
      })
        .then(response => {
          // set state cost menjadi true, untuk menampilkan pilihan cost pengiriman
          state.cost = true
          // assign state cost dengan hasil response
          state.costs = response.data.data.costs
        }).catch(error => {
          console.log(error);
        })
    }

    // function untuk mengambil biaya ongkos kirim dan service courier
    function getCostService() {
      // split value dengan manghapus string -> |
      let shipping = state.costService.split("|")

      // set cost dan service
      state.courier_cost = shipping[0];
      state.courier_service = shipping[1];

      // get token
      const token = store.state.auth.token
      Api.defaults.headers.common['Authorization'] = "Bearer " + token

      // hitung grand total
      Api.get('/carts/total')
        .then(response => {
          // jumlah total cart dan cost pengiriman
          state.grandTotal = parseInt(response.data.total) + parseInt(state.courier_cost);
        })

      // show button checkout
      state.buttonCheckout = true
    }

    // method / function checkout
    function checkout() {
      if (state.name && state.phone && state.address && cartWeight.value) {
        // define variable

        let data = {
          name: state.name,
          phone: state.phone,
          province_id: state.province_id,
          city_id: state.city_id,
          courier_type: state.courier_type,
          courier_service: state.courier_service,
          courier_cost: state.courier_cost,
          weight: cartWeight.value,
          address: state.address,
          grandTotal: state.grandTotal
        }
        store.dispatch('cart/checkout', data)
          .then(response => {
            // jika berhasil arahakan ke detail order dengan snap_token midtrans
            router.push({
              name: 'detail_order',
              params: {
                snap_token: response[0].snap_token
              }
            })
          }).catch(error => {
            console.log(error)
          })
      }

      //check validasi name
      if (!state.name) {
        validation.name = true
      }

      //check validasi phone
      if (!state.phone) {
        validation.phone = true
      }

      //check validasi address
      if (!state.address) {
        validation.address = true
      }
    }

    return {
      carts, // state carts
      cartTotal, // state cartTotal
      cartWeight, // state cartWeight
      removeCart, // method removeCart
      state,
      validation,
      provinces,
      getCities,
      getCourier,
      getOngkir,
      getCostService,
      user,
      checkout,
    };
  },
};
</script>
